AverageDuplic <- function(mat, duplic, pheno, id=NULL,RemoveUnpaired = F,Block = NULL) {
  # The function is called by WriteDataToFiles() in <WriteDataToFiles.R> only.
  # Input:
  #   mat: a matrix
  #   duplic=a string of characters
  #   pheno=a string of characters
  #   Block=a string of characters or NULL
  # Assume CheckPheno(duplic,pheno)==TRUE
  # Example:
  #   duplic <- c('4','4','2','2','3','3','3','5','5')
  #   pheno <- c('a','a','b','b','b','b','b','a','a')
  #   mat <- matrix(1:45, nr=5); mat[1,1] <- NA
  #   tmp <- AverageDuplic(mat,duplic,pheno);tmp

  if (is.null(id))  id <- duplic
  nc <- length(unique(duplic))
  newmat <- matrix(0, nr=nrow(mat), nc=nc)
  newpheno <- rep(0, nc)
  HasBlock <- !is.null(Block)
  newBlock <- NULL
  if(HasBlock) newBlock <- rep(0, nc)
  newid <- rep(0, nc)
  j <- 0
  for(i in sort(unique(duplic)))   {
    ind <- which(duplic==i)
    if (length(ind)==1) {
      tmp <- mat[,ind]
    } else {
      tmp <- apply(mat[,ind],1,mean, na.rm=TRUE)
    }
    j <- j+1
    newmat[,j] <- tmp
    newpheno[j] <- pheno[ind[1]]
    if(HasBlock) newBlock[j] <- Block[ind[1]]
    newid[j] <- id[ind[1]]
  }
  if(RemoveUnpaired) {
    code <- rep(T,length(newid))
    for(i in 1:length(newid) ) {
      code[i] <- (length(newid[newid == newid[i] ]) == 2) &
        (length(unique(newpheno[newid == newid[i] ])) == 2 )
    }
    newmat   <- newmat[,code]
    newid    <- newid[code]
    newpheno <- newpheno[code]
  }
  dimnames(newmat) <- NULL
  return(list(mat=newmat, pheno=newpheno, id=newid,block = newBlock))
}
